package java_sound;

import java.io.*;
import javax.sound.sampled.*;

public class AufnahmeAbspielen extends Thread {
    static MikroAufnahme rec;
    static ByteArrayInputStream baIn;
    static byte[] caB, ba;
    static DataLine.Info info;
    static AudioInputStream stream;
    static AudioFormat neuesFormat;
    static SourceDataLine sourceLine_3;
    static int AnzahlGelBytes;
    static FloatControl gainControl;


    public AufnahmeAbspielen() {
    }

    public void run() {

        //Bytearray mit augenommenen Bytes holen
        caB = rec.baOut.toByteArray();
        
        //Bytearray an ByteArrayInputStream bergeben
        baIn = new ByteArrayInputStream(caB);

        System.out.println("Jetzt abspielen");
        System.out.println("Anzahl der gecapturten Bytes: " + caB.length);

        //Datenformat der Aufnahme holen
        neuesFormat = rec.neuesFormat;
        
        //neuen AudioInputStream mit Lnge des ByteArrayInputStreams (Anzahl der Sample frames)
        stream = 
        
        //Info-Objekt fr SRC-DataLine zum Abspielen erzeugen mit Format des Streams
        info = new DataLine.Info(SourceDataLine.class, stream.getFormat());



        try {
            //SourceLine erzeugen
            sourceLine_3 = (SourceDataLine) AudioSystem.getLine(info);
        } catch (LineUnavailableException e) {
            System.out.println("SourceDataLine konnte nicht benutzt werden");
            System.exit(1);
        }
        try {
            //SRC-Line ffnen
            sourceLine_3.open();
        } catch (LineUnavailableException e) {
            System.out.println("Fehler beim ffnen des AudioStreams");
            System.exit(1);
        }

       //Lautstrke anpassen
        if (sourceLine_3.isControlSupported(FloatControl.Type.MASTER_GAIN)) {
            gainControl = (FloatControl) sourceLine_3.getControl(FloatControl.Type.MASTER_GAIN);
            if (gainControl!=null) gainControl.setValue(6.0f);
        }

        //SRC-Line starten
        sourceLine_3.start();
        
        //Lesepuffer
        ba = new byte[64];
        
        //Thread zum Gleichzeitigen Abspielen des Soundfiles (Musikstck starten);
        SoundFileAbspielen ab = new SoundFileAbspielen();
        ab.start();
        
        
        while (true) {
            try {
                //Bytes in Puffer lesen
                AnzahlGelBytes = stream.read(ba, 0, 64);
            } catch (IOException e) {
                System.out.println("Fehler beim Lesen der SounddateiDaten");
                System.exit(1);
            }
            
            //Stop, wenn keine Bytes mehr vorhanden
            if (AnzahlGelBytes == -1)
                break;
                
            //Bytes zum Abspielen auf SourceLine schreiben
            sourceLine_3.write(ba, 0, ba.length);
        }

        //Wernn fertig, SRC-Line leeren
        sourceLine_3.drain();
        sourceLine_3.stop();
        sourceLine_3.close();
        System.out.println("Endliche FERTIG!");
        System.exit(0);
    }


}